;;
;; $Id: login.scm,v 1.5 2005/08/01 15:24:16 ben Exp $
;;
;; This is where our login code lives. You don't need to log in
;; to view the store, just to buy something
;;

(require-library 'com/amazingmedia/sps/web/context-helper)
(require-library 'com/amazingmedia/sps/web/button)
(require-library 'com/amazingmedia/util/context)

(module com/amazingmedia/sps/ui/login
    (login/prompt login/logout)
  
  (import com/amazingmedia/sps/web/context-helper)
  (import com/amazingmedia/sps/web/button)
  (import com/amazingmedia/util/context)

  ;;
  ;; Ask a user to log in
  ;;
  ;; ctx -- the context to use to log in
  ;; username -- the login id to use, may be null
  ;; success-k -- a 1 arg thunk that takes in a context and 
  ;;              takes the user somewhere, after they have
  ;;              logged in
  ;;
  (define (login/prompt ctx username password success-k)
    (render 
     ctx
     `(basic-page 
       (title "Log In")
       (div
        ,(use-form ctx 'login
                   (lambda (ctx username password)
                     (success-k
                      (context/put 'logged-in-as username ctx)))
                   (lambda (ctx username password)
                     (apply-nav ctx 'login username password success-k))
                   username password)
        ,(button/generic ctx "No account? Register now"
                         (lambda (ctx)
                           (apply-nav ctx 'register #f success-k)))))))


  ;;
  ;; Log a user out, this does things like empty their shopping
  ;; cart and other fun stuff.
  ;;
  ;; ctx -- the context in use
  ;;
  (define (login/logout ctx)
    (let ((ctx (context/put 'logged-in-as #f
                            (empty-cart ctx))))
      (render-final
       ctx
       `(basic-page
         (title "Logged Out")
         (div
          (p "You have been logged out. Have a nice day.")
          ,(button/landing ctx "Shop Again"))))))
       

  )