;;
;; $Id: store.scm,v 1.14 2005/08/08 18:29:03 ben Exp $
;;
;; Scheme code to kick off the petstore itself
;;



(require-library 'com/amazingmedia/sps/web/context-helper)
(require-library 'com/amazingmedia/sps/ui/landing)

(require-library 'com/amazingmedia/sps/db/query)
(require-library 'com/amazingmedia/sps/web/form)
(require-library 'com/amazingmedia/sps/web/nav-points)
(require-library 'com/amazingmedia/sps/web/layout)

(require-library 'siscweb/bindings)


(module com/amazingmedia/sps/ui/store
    (store)

  (import com/amazingmedia/sps/ui/landing)
  (import com/amazingmedia/sps/web/context-helper)

  (import com/amazingmedia/util/context)
  (import com/amazingmedia/web/item)
  (import com/amazingmedia/web/history)
  (import com/amazingmedia/web/messages)
  (import siscweb/bindings)

  (define-syntax from*
    (syntax-rules ()
      ((_ module fn)
       (lambda args
         (apply (from module fn) args)))))

  (define (store req)
    (let ((ctx (make-initial-context (from* com/amazingmedia/sps/db/query   
                                            all-queries)
                                     (from* com/amazingmedia/sps/web/layout 
                                            all-layouts)
                                     (from* com/amazingmedia/sps/web/form
                                            all-forms)
                                     (from* com/amazingmedia/sps/web/nav-points
                                            all-nav-points))))
      (let-bindings ((cmd "c") (argument "a")) 
          (get-bindings req)
        (define (arg)
          (if argument argument '()))
        (set! req #f)
        (cond ((equal? cmd "product")
               (apply-nav ctx 'view-product (arg)))
              ((equal? cmd "category")
               (apply-nav ctx 'view-category (arg)))
              ((equal? cmd "item")
               (apply-nav ctx 'view-item (arg)))
              ((equal? cmd "search")
               (apply-nav ctx 'search (arg)))
              (else 
               (apply-nav ctx 'landing))))))

  )
