;;
;; $Id: view.scm,v 1.11 2005/08/09 13:15:51 ben Exp $
;;
;; Scheme code to implement various views, such as products, items, etc.
;;


(require-library 'com/amazingmedia/sps/web/button)
(require-library 'com/amazingmedia/sps/web/context-helper)
(require-library 'com/amazingmedia/util/context)

(module com/amazingmedia/sps/ui/view
    (view/category view/product view/item)

  (import com/amazingmedia/sps/web/context-helper)
  (import com/amazingmedia/sps/web/button)
  (import com/amazingmedia/util/context)

  (define (not-found what id)
    `(basic-page
      (title ,what " Not Found")
      (div "Sorry, the " ,what " " (i ,id) " can not be found")))

  (define (view/category ctx category)
    (render 
     (add-direct-link ctx "category" category)
     `(simple-results
       (title ,category)
       (labels "Product ID" "Product Name")
       ,@(map-query ctx find-products-by-category-name
                    (category) 
                    (product-id name)
           `(row ,product-id
                 ,(button/view-product ctx "" product-id name))))))

  (define (view/product ctx product-id)
    (let-query ctx lookup-product-by-id
               (product-id) (product-name category-name)
      (render 
       (add-direct-link ctx "product" product-id)
       (if product-name
           `(simple-results
             (title ,product-name)
             (labels "Item ID" "Item Name" "Price" "# Available" nbsp)
             ,@(map-query ctx find-items-by-product-id
                          (product-id)
                          (item-id name price quantity)
                 `(row ,product-id 
                       ,(button/view-item ctx item-id name)
                       ($ ,price)
                       ,quantity
                       ,(if (positive? quantity)
                            (button/add-to-cart ctx item-id price 1)
                            "Sold Out"))))
           (not-found "Product" product-id)))))
                    

  (define (view/item ctx maybe-item-id)
    (let-query ctx  lookup-item-by-id (maybe-item-id)
               (item-name product-name product-id description 
                          list-price image item-id quantity)
      (render
       (add-direct-link ctx "item" item-id)
       (if item-name
           `(item-details
             (id ,item-id)
             (name ,item-name)
             (price ,list-price)
             (available ,quantity)
             (description ,description)
             (image ,image))
           (not-found "Item" maybe-item-id)))))
    

  )