;;
;; $Id: context-test.scm,v 1.3 2005/08/02 19:23:13 ben Exp $
;;
;; Scheme code to play around w/ contexts
;;

(require-library 'com/amazingmedia/util/simple-tester)

(import com/amazingmedia/util/context)
(import com/amazingmedia/util/simple-tester)

(let ((ctx (make-context 'immutable
                         `((a . 10)
                           (b . ,(make-context 
                                  'immutable
                                  '((d . 5)
                                    (f . -2))
                                  >
                                  equal?
                                  (lambda (x y)
                                    (+ x y))))))))
  [run-tests
   (lambda () ;0
     (equal? (context/get 'a ctx) 10))
   (lambda () ;1
     (equal? (context/get '(a) ctx) 10))
   (lambda () ;2
     (record? (context/get '(b) ctx)))
   (lambda () ;3
     (equal? (context/get '(b d) ctx) 5))
   (lambda () ;4
     (equal? (context/get '(b p) ctx) #f))
   (lambda () ;5
     (equal? (context/get '(b p)
                          (context/put '(b p)
                                       100
                                       ctx))
             100))
   (lambda () ;6
     (equal? (context/get '(b p)
                          (context/add '(b p)
                                       2
                                       (context/put
                                        '(b p)
                                        100
                                        ctx)))
             102))
   (lambda () ;7
     (equal? (context/map 'b
                  (lambda (v)
                    (* -1 v))
                  (context/add '(b p)
                               2                               
                               (context/put
                                '(b p)
                                100
                                ctx)))
             '(-102 -5 2)))
   (lambda () ;8
     (define mctx (context/put 'm (make-context 'mutable
                                                '() > equal? 
                                                (lambda (x y)
                                                  (+ x y)))
                               ctx))
     (context/put '(m a) 3 mctx)
     (context/put '(m b) 4 mctx)
     (equal? 3 (context/get '(m a) mctx)))
   (lambda () ;9
     (define mctx (context/put 'm (make-context 'mutable
                                                '() > equal? 
                                                (lambda (x y)
                                                  (+ x y)))
                               ctx))
     (context/add '(m a) 3 mctx)
     (context/add '(m a) 4 mctx)
     (equal? 7 (context/get '(m a) mctx)))

   ])