;;
;; $Id: simple-tester.scm,v 1.2 2005/07/18 15:16:18 ben Exp $
;;
;; Scheme code to do *very* simple testing. Basically, this is
;; a quick testing framework so that I can write simple unit
;; tests
;;


(require-library 'sisc/libs/srfi/srfi-42)

(module com/amazingmedia/util/simple-tester
    (run-tests)

  (import debugging)
  (import srfi-42)

  ;;
  ;; We assume that we are handed a series of thunks,
  ;; which we will run, and display OK/Fail/Error
  ;;
  ;; That's it -- nice and simple :-).
  ;;
  ;; tests -- a list of thunks to run, returning true
  ;;         if the test passed
  ;;
  (define (run-tests . tests)
    (newline)
    (do-ec (: test (index i) tests)
           (begin
             (display (format "~4,0F:  " i))
             (with/fc (lambda (e k)
                        (display (format "Error: ~a\n" (error-message e)))
                        (print-stack-trace k))
                      (lambda ()
                        (cond ((test) 
                               (display "OK\n") #t)
                              (else
                               (display "Failed\n") #f))))))))