;;
;; $Id: string.scm,v 1.2 2005/07/08 18:23:40 ben Exp $
;;
;; Scheme code to support utility transformations on strings
;;

(require-library 'sisc/libs/srfi/srfi-13)

(module com/amazingmedia/util/string
    (any->string 
     any-string-join
     any-string-append)

  (import srfi-13)

  ;;
  ;; Convert anything into a string and return it
  ;;
  (define (any->string value)
    (format "~a" value))

  ;;
  ;; Join together the string'ified values into 
  ;; one string seperated by sep
  ;;
  (define (any-string-join values sep)
    (string-join (map any->string values) sep))

  ;;
  ;; string'ify and append all the input values
  ;;
  (define (any-string-append . values)
    (apply string-append (map any->string values))))