;;
;; $Id: direct-link.scm,v 1.1 2005/08/08 18:29:03 ben Exp $
;;
;; Scheme code to deal with direct-links. A direct link is my answer
;; to deep linking. Some pages have the ability to be addressable directly
;; as a bookmarkable link. This the direct-link.
;;
;; A page can have a single direct link associated with it.
;;

(require-library 'sisc/libs/srfi/srfi-13)

(module com/amazingmedia/web/direct-link
    (make-direct-link render-direct-link)

  (import record)
  (import srfi-13)

  (define-struct direct-link (command args))

  (define (render-direct-link dl)
    `(script (*COMMENT* 
              ,(string-join
                (list "//"
                      (format "directLink('~a','~a');\n"
                              (direct-link-command dl)
                              (string-join (direct-link-args dl) "','"))
                      "//")
                "\n"))))

  )
                       
              
