;;
;; $Id: error.scm,v 1.1 2005/07/15 12:52:43 ben Exp $
;;
;; Deal with errors on the web. For example, when an error
;; is thrown we can't simply die -- we need to show a nice
;; and pretty error page.
;;

(require-library 'siscweb/html)

(module com/amazingmedia/web/error
    (web-error-handler)

  (import siscweb/html)
  (import debugging)
  (import string-io)


  ;;
  ;; Our default web-error-handler.  This is useful as in:
  ;;  (with/fc web-error-handler (lambda () ... stuff ...))
  ;;
  ;; This guys tries to show an informative error page.
  ;;
  (define (web-error-handler error error-k)
    (let ((trace (with-output-to-string (lambda ()
                                          (print-stack-trace error-k)))))
      (with-
      (send-html/back
       `(html
         (head (title "Unexpected Error"))
         (body (@ (class "error"))
               (p "Error Page: "
                  ,(error-message error))
               (pre ,trace))))))))
