;;
;; $Id: item-test.scm,v 1.3 2005/08/02 19:23:13 ben Exp $
;;
;; Scheme code to test out the item stuff
;;


(require-library 'com/amazingmedia/util/simple-tester)

(import com/amazingmedia/util/simple-tester)
(import com/amazingmedia/web/item)
(import com/amazingmedia/util/context)

(let ((cart (context/put
             'cat
             (make-item "cat" 2.00 1)
             (context/put
              'dog
              (make-item "dog" 3.90 2)
              (make-context 'mutable '()
                            item<?
                            equal?
                            combine-items)))))
  [run-tests
   (lambda ()
     (equal? 2.00
             (item-price (context/get 'cat cart))))
   (lambda ()
     (equal? 2
             (item-quantity (context/get 'dog cart))))
   (lambda ()
     (equal? 5.90
             (apply + (context/map item-price
                                   cart))))
   (lambda ()
     (equal? '("dog" "cat" "fish")
             (context/map item-id 
                          (context/put 'fish
                                       (make-item "fish" .99 3)
                                       cart))))

   (lambda ()
     (equal? '("dog" "cat" "fish")
             (context/map item-id 
                          (context/put 'fish
                                       (make-item "fish" .99 3)
                                       (context/put 'dog
                                                    (update-item-quantity (context/get 'dog cart) 40)
                                                    cart)))))
   
  ])