;;
;; $Id: messages.scm,v 1.2 2005/08/02 19:23:13 ben Exp $
;;
;; Scheme code to support messages in an application. For now, messages
;; are just a list of text strings stored in a context.
;;

(require-library 'com/amazingmedia/util/context)
(require-library 'sisc/libs/srfi/srfi-26)

(module com/amazingmedia/web/messages
    (make-messages-context
     has-messages?
     clear-messages)

  (import srfi-26)
  (import com/amazingmedia/util/context)


  ;;
  ;; Return back a new context suitable for holding different
  ;; kinds of messages
  ;;
  ;; types -- a list of symbols, such as '(error warning)
  ;;
  ;;
  (define (make-messages-context types)
    (make-context 'immutable
                  (map (cut cons <> '())
                       types)
                  #f
                  equal?
                  (lambda (old new)
                    (append old (list new)))))

  ;;
  ;; Does this context contain any messages in the selected
  ;; type.
  ;;
  ;; type - the type to check
  ;; ctx  - the context to check
  ;;
  (define (has-messages? type ctx)
    (not (eq? (context/get type ctx) '())))

  ;;
  ;; Clears out a given type of messages in our context
  ;; and return the updated context
  ;;
  (define (clear-messages type ctx)
    (context/put type '() ctx))

  )