--
-- $Id: siscweb-schema.sql,v 1.1 2005/08/15 15:42:13 ben Exp $
--
-- The schema used to store siscweb details
-- in the database
--
-- taken from: ks-postgresql.scm
--
--

CREATE TABLE continuation (
    id                      integer         PRIMARY KEY,
    jsessionid              char(32)        NOT NULL,
    hash                    char(40)        NOT NULL,
    creation_time           date            DEFAULT now() NOT NULL,
    visit_time              date,
    ttl                     integer         DEFAULT 1200 NOT NULL,
    expiration_time         date            NOT NULL,
    parent                  integer,
    procedure               bytea,          
    FOREIGN KEY (parent)                    REFERENCES continuation(id) 
                                            ON DELETE SET NULL);


CREATE UNIQUE INDEX continuation_uniq_idx ON continuation(jsessionid, hash);
CREATE INDEX continuation_expr_time_idx ON continuation(expiration_time);
CREATE INDEX continuation_parent_idx ON continuation(parent);
CREATE SEQUENCE continuation_seq;

